#!/bin/bash
#
# Component: cases
#
# Description:
#
# Usage:
#   checkLockedUsers
#

. $HOME/etc/setenv.sh

if [ -f $CONF/lockusers.conf ] ; then
	. $CONF/lockusers.conf
else
	if [ -f $CASES_HOME/cfg/lockusers.conf ] ; then
		. $CASES_HOME/cfg/lockusers.conf
	else
			echo "no config file!"
			exit 1	
	fi
fi

echo "keeplogins:$keeplogins"
if [ ! -z "$keeplogins" ] ; then
	now=`date +%s`
	echo "now:"$now
	update="delete from FailedLogin where $now>=FLEVENTDATETIME+($keeplogins*86400)"
	echo "$update"
	${TOOLS_HOME}/sql.sh "$update" -N
fi