
<%@page import="com.erad.pacs.modules.gwt.descriptors.action.ActionType"%>
<%@page import="com.erad.pacs.store.EPDBConnector"%>
<%@page import="com.erad.pacs.store.SmartPreparedStatement"%>
<%@page import="com.erad.pacs.toolbox.UserRequestResponseToolbox"%>
<%@page import="com.erad.pacs.app.broker.table.internals.action.DcActionImpl.IMListFilterException"%>
<%@page import="com.erad.pacs.services.broadcast.SystemBroadcast"%>
<%@page import="imagemed.exception.IMListFileReadException"%>
<%@page import="imagemed.http.tabs.TabBean"%>
<%@page import="com.erad.pacs.toolbox.ListDbToolbox"%>
<%@page import="com.erad.pacs.modules.gwt.exception.EPException"%>
<%@page import="com.erad.pacs.toolbox.ActionDbToolbox"%>
<%@page import="com.erad.pacs.entities.actions.BaseAction"%>
<%@page import="com.erad.pacs.modules.gwt.session.user.Group"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.common.libs.RequestInfo"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.services.usermanager.client.Envelope"%>
<%@page import="com.erad.pacs.modules.gwt.descriptors.usermanager.LoginWithKeyModule"%>
<%@page import="cases.ActionjspKeystoreParam"%>
<%@page import="com.erad.pacs.toolbox.LoginServiceToolbox"%>
<%@
	page import = "java.io.*,java.sql.*,java.util.*,java.text.Format,com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*,com.erad.pacs.app.broker.table.internals.action.*,com.erad.pacs.app.broker.table.internals.lists.*,com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,com.erad.pacs.common.interfaces.action.DcAction,com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,com.erad.pacs.connector.Connector,imagemed.util.*,imagemed.imsession.*,imagemed.types.flag.*,imagemed.imtables.queryqualifier.QueryQualifier,imagemed.summaries.*,com.erad.pacs.toolbox.KeystoreToolbox,java.security.KeyStore.PrivateKeyEntry"

%><%-- ----- Helper Functions ----- --%><%!// lock related stuff

// static boolean bReentry = false;

// synchronized static boolean lock() {
// 	if ( bReentry )
// 		return false;
// 	bReentry = true;
// 	return true;
// }

// static void unlock() {
// 	bReentry = false;
// }
// end of lock related stuff

private static PrivateKeyEntry privateKey = null;

private static final String MSG_PREFIX = "action_jsp-";

/**
 * Load private key from keystore only once and return instance.
 */
private static PrivateKeyEntry getPrivateKeyEntry() throws Exception {
	if (privateKey == null) {
		ActionjspKeystoreParam param = new ActionjspKeystoreParam();
		privateKey = KeystoreToolbox.loadKeystoreEntry( param.getKeystoreType(), param.getKeystorePath(  ), param.getKeystorePw(), param.getKeyAlias(), param.getKeyPw() );
	}
	return privateKey;
}

private static Set<String> ACTIVE_MUTEXES = new HashSet<String>();

void checkAction( JspWriter out, HttpServletRequest request, HttpServletResponse response, RequestInfo requestInfo, String actionId, boolean checkSlow, Set<String> activeMessages ) throws ReflectiveOperationException, IOException, EPException, SessionException {
	// prevent reentry on actionId basis
	String mutex = actionId.intern();
	BaseAction<?> action;
	synchronized( mutex ) {
		action = ActionDbToolbox.loadAction( actionId );
		if ( ACTIVE_MUTEXES.contains( mutex ) ) {
			// add possible message names to prevent erroneous message removal for skipped actions
			DcAction dcAction = action.getDcAction();
			activeMessages.add( MSG_PREFIX + "slowAction-" + action.getListOwner() + "-" + action.getListName() + "-"+ dcAction.getName() );
			activeMessages.add( MSG_PREFIX + "brokenFilterAction-" + action.getListOwner() + "-" + action.getListName() + "-"+ dcAction.getName() );
			
			out.println( "&nbsp;<br><b><i>-- Skipping in-process " + dcAction.getName() + " action on " + action.getListOwner() + "'s " + action.getListName() + " --</i></b><BR>&nbsp;<br>\n" );
			return; // this user+list+action is being processed 
		}
		ACTIVE_MUTEXES.add( mutex );
	}
	try {
		
		// delay for testing
// 		try {
// 			out.flush();
// 			Thread.sleep( 10000 );
// 		}
// 		catch (InterruptedException ie) {}
		
		checkActionInternal( out, request, response, requestInfo, action, checkSlow, activeMessages );
	}
	finally {
		ACTIVE_MUTEXES.remove( mutex );
	}
}

void checkActionInternal( JspWriter out, HttpServletRequest request, HttpServletResponse response, RequestInfo requestInfo, BaseAction<?> action, boolean checkSlow, Set<String> activeMessages ) throws ReflectiveOperationException, IOException, EPException, SessionException {
	UserManagerFacade um = Connector.getInstance().get( UserManagerFacade.Caller );
	Envelope userEnvelope = null;
	try {
		try {
			userEnvelope = LoginServiceToolbox.loginService( um, new ActionjspKeystoreParam(), action.getListOwner() );
		}
		catch (Throwable se){
			if (se.getMessage() != null && se.getMessage().startsWith( "Non existing user:" )){
				userEnvelope = LoginServiceToolbox.loginService( um, new ActionjspKeystoreParam(), null );
				Session session = UserRequestResponseToolbox.checkEnvelope( request, response, userEnvelope );
				ActionDbToolbox.deleteAction( action.getCommonPart().getId(), false, session );
				Helper.ERRORLOG( "action.jsp", "User "+ action.getListOwner() +" does not exist, deleting action." );
			}
			throw se;
		}
	}
	catch ( Throwable e ) {
		Helper.ERRORLOG( "action.jsp", "Executing actions on " + action.getListOwner() + "'s " + action.getListName() + " list failed: Login failed: " + e.getMessage(  )  );
		return;
	}

	Session userSession;
	try {
		userSession = UserRequestResponseToolbox.checkEnvelope( request, response, userEnvelope );
	} catch (SessionException se) {
    	out.println( "Session exception occured for user '" +  action.getListOwner() + "': " + se.getMessage() );
    	Helper.ERRORLOG( "action.jsp", "Executing actions on " +  action.getListOwner() + "'s " + action.getListName() + " list failed: " + se.getMessage() );
    	return;
	} catch ( Throwable t ) {
		out.println(Helper.throwable2String( t ));
		Helper.ERRORLOG( "action.jsp", "Executing actions on " +  action.getListOwner() + "'s " + action.getListName() + " list failed: " + Helper.throwable2String( t ) );
		return;
	}
	
	try {
		if (ListDbToolbox.hasMacro(userSession, action.getListOwner(), action.getListName())){
			Helper.ERRORLOG( "action.jsp", "Executing actions on " + action.getListOwner() + "'s " + action.getListName() + " list failed: The list conatains macro." );
			return;			
		}		
	}	catch ( Throwable e ) {
		Helper.ERRORLOG( "action.jsp", "Executing actions on " + action.getListOwner() + "'s " + action.getListName() + " list failed: Checking macro failed: " + e.getMessage(  )  );
		return;
	}

	DcAction dcAction = action.getDcAction();
	if (! userSession.getRights().hasRight( dcAction.getReqRights() )) {
		Helper.ERRORLOG( "action.jsp", "Executing actions on " + action.getListOwner() + "'s " + action.getListName() + " list failed: No " + dcAction.getReqRights() + " right. Disabling action."  );
		ActionDbToolbox.deleteAction( action.getCommonPart().getId(), false, userSession );//SRV-827
		return;
	}
	
	out.println( "<B>" + dcAction.getName() + "</B><BR>" );
	// listname.ip.ip.ip.ip.xxx

	dcAction.setAction( action);

	if ( !userSession.getRights().hasRight( PacsRight.RestrictedQuery ) ) {
		//re-check slow query
		
		if ( checkSlow ) {
			String mesName = MSG_PREFIX + "slowAction-" + action.getListOwner() + "-" + action.getListName() + "-"+ dcAction.getName();
			//message must be deleted, when the query is not slow!
			// because message doesn't do any deleting
			try {
				QueryQualifier qq = new QueryQualifier();
				String qualif = qq.qualifyFilters( userSession, new WorklistTableParamsImpl(userSession, action.getListOwner(), action.getListName(), false, null ), true, true );
				if( !QueryQualifier.GOOD.equals( qualif ) ) {
					String problem = LocalizedMessage.getCompoundMessage( "QQ_BAD_QUERY_ACTION_RUNNING", new Format[]{ null, null, null }, new Object[]{ action.getListOwner(), action.getListName(), dcAction.getName() }, false );
					out.print( problem + "<BR>\n" );
					List<String> mes = new ArrayList<String>();
					mes.add( "<center>" + problem + "</center>" );
					IMMessage.createMessage( mesName, mes, null, new String[]{ Group.ADMIN_GROUP_ID }, 10000000, 1440, false, true );
					activeMessages.add( mesName );
				}
				else {
					IMMessage.delete( mesName );
				}
			}
			catch( Throwable th ) {
				Helper.defaultCatch( th );
			}
		}
	}

	
	out.print( "checking " + action.getListOwner() + "'s " + action.getListName() + "<BR>\n" );
	UserListImpl.acquireListLock( action.getListOwner(), action.getListName() );
	String mesName = MSG_PREFIX + "brokenFilterAction-" + action.getListOwner() + "-" + action.getListName() + "-"+ dcAction.getName();
	try {
		out.println( dcAction.checkAction( userSession, request, requestInfo ) );
		IMMessage.delete( mesName );
	}
	catch ( IMListFileReadException imlfe ) {
		try {
			Helper.ERRORLOG( "action.jsp", "Checking/executing actions on " + action.getListOwner() + "'s " + action.getListName() + " list failed: " + imlfe.getMessage() );
			Helper.INFOLOG( Helper.toString( imlfe ) );
			out.println( imlfe.getMessage() );

			List<String> mes = new ArrayList<String>();
			mes.add( "<center>" + imlfe.getMessage() + "</center>" );
			IMMessage.createMessage( mesName, mes, null, new String[]{ Group.ADMIN_GROUP_ID }, 10000000, 1440, false, true );
			activeMessages.add( mesName );
		}
		catch ( Exception ex ) {
		}
	}
	catch ( Exception e ) {
		try {
			Helper.ERRORLOG( "action.jsp", "Checking/executing actions on " + action.getListOwner() + "'s " + action.getListName() + " list failed: " + Helper.throwable2String( e ) );
			Helper.INFOLOG( Helper.toString( e ) );
			out.println( Helper.throwable2String( e ) );
		}
		catch ( Exception ex ) {
		}
	}
	finally {
		UserListImpl.releaseListLock( action.getListOwner(), action.getListName() );
	}
	
/*

	This was within checkUser() {}
	Probably could work from the Summary SQL table
		
	// check summaries
	for( int i = 0; i < GenericUserListImpl.LIST_SUBDIRS.length; i++ ) {
		String[] filterNames = UserListImpl.getFilterNames( userName, i );
		Summary[] sums = SummaryManager.getSummaries( i );
		for( int j = 0; j < filterNames.length; j++ ) {
			UserListImpl.acquireListLock( userName, i, filterNames[ j ] );
			try {
				for( int k = 0; k < sums.length; k++ ) {
					sums[ k ].checkAndRun( userSession, sessita.getRequestInfo(  ), userName, i, filterNames[ j ] );
				}
			}
			catch( Exception e ) {
				Helper.defaultCatch( e );
			}
			finally {
				UserListImpl.releaseListLock( userName, i, filterNames[ j ] );
			}
		}
	}
*/	
	
	//TODO logoff user without logging
}%><%
// 	if ( !lock() ) {
// 		Helper.INFOLOG( "action.jsp could not get lock (cannot reenter)" );
// 		out.println( "cannot reenter" );
// 		return;
// 	}

	try{
		TabBean.checkLicense( false );
	}
	catch (Exception e){
		Helper.INFOLOG( "action.jsp could no check license" );
		out.println( "cannot check license" );
		Helper.defaultCatch( e );
		return;
	}

	try {
		String owner = request.getParameter( "owner" );
		String listName = request.getParameter( "listname" );
		String action = request.getParameter( "action" );
		String log = "action.jsp start";
		if (owner != null || listName != null || action != null){
			log += ( " with parameters: owner(" + owner + ") listName(" + listName + ") action(" + action + ")");
		} 
		Helper.INFOLOG( log );
		
		ActionType actionType = null;
		try{
			if (action != null){
		 		actionType = ActionType.valueOf(action) ;
			}
		}
		catch ( IllegalArgumentException e ) {
			Helper.ERRORLOG( "action.jsp called with unknown action: " + action );
			throw e;
		}
		if ( ! LoginServiceToolbox.checkServerIp( request.getRemoteAddr() ) ) {
	// when called fom remote IP check for a user session 
	UserRequestResponseToolbox.getSessitaSession( request, response );
		}

		RequestInfo requestInfo = new RequestInfo(request);		
		
		//sess.createIMRequest( false );
		
		//is.sessionVariables.setProperty("actionJsp", "true"); // TODO

		boolean checkSlow = false;
		GregorianCalendar now = new GregorianCalendar();
		String actDate = Helper.calcDayStr( now );
		try ( SmartPreparedStatement sps = EPDBConnector.getCachedSps( "select * from Env" ) ) {
	try ( ResultSet rs = sps.executeQuery() ) {
		if( rs.next( ) ) {
			String lastDate = rs.getString( "SLOWQUERYCHECK" );
			if( !actDate.equals( lastDate ) ) {
				checkSlow = true;
			}	
		}
	}
		}
		catch( Throwable th ) {
	Helper.defaultCatch( th );
		}
		
		Set<String> activeMessages = new HashSet<String>();
		for ( String actionId : ActionDbToolbox.getAllActiveActionIds(owner, listName, actionType) ) {
			checkAction( out, request, response, requestInfo, actionId, checkSlow, activeMessages );
		}
		
		// check and remove inactive action.jsp messages
		for ( String msg : IMMessage.listMessageNames( MSG_PREFIX ) ) {
	if ( !activeMessages.contains( msg ) ) {
		IMMessage.delete( msg );
	}
		}
		
		Helper.DEBUG( "checking all summaries" );
		UserManagerFacade um = Connector.getInstance().get( UserManagerFacade.Caller );
		Envelope envelope = null;
		try {
	envelope = LoginServiceToolbox.loginService(um, new ActionjspKeystoreParam(), null);
		}
		catch ( Exception e ) {
	Helper.ERRORLOG( "action.jsp", "Summary checking: Login failed: " + e.getMessage(  )  );
	return;
		}

		Session actionSession = UserRequestResponseToolbox.checkEnvelope( request, response, envelope );
		SummaryManager.checkAndRunAll( actionSession, requestInfo );

		if ( checkSlow ) {              
	try ( SmartPreparedStatement sps = EPDBConnector.getCachedSps( "update Env set SLOWQUERYCHECK=?" ) ) {
		sps.setStringArg( 1, actDate );
		sps.executeUpdate();
	}
		}
	}
	finally {
		Helper.INFOLOG( "action.jsp end" );
		//unlock();
	}
%>