<%--
 * Component: cases
 *
 * Description:
 *    Updates the CacheState database table with the current loaded percent of studies on a workstation (viewer cache).
 *
 * Parameters:
 *    CacheInfo : cache information. Below is an example:
 *
 * *Example of input (CacheInfo)
 * Version PBS001
 * WorkstationID 193.68.54.149
 * StudyCount 3
 * StudyUID 999.999.3859744
 * StudyRate 50
 * StudyUID 1.2.840.113674.1115.261.200
 * StudyRate 100
 * StudyUID 1.2.840.113704.3.1.429231.343410.121952.38
 * StudyRate 33
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%>
<%@page import="com.erad.pacs.toolbox.UserRequestResponseToolbox"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="imagemed.util.Helper"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.jsputil.CacheStateToolbox"%>
<%@ page trimDirectiveWhitespaces="true" %>
><%
	response.setHeader( "protocolVersion", "1" );
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = null;
	try {
		sess = UserRequestResponseToolbox.getSessitaSessionNoSessParCheck( request, response );
	} catch ( SessionException se ) {
		Helper.DEBUG( "updatecachestate.jsp called without active session." );
		return;
	}
	
	CacheStateToolbox.doWork( sess, request, response );	
%>