<%@page import="com.erad.pacs.toolbox.UserRequestResponseToolbox"%>
<%@page import="imagemed.dotcom.DotcomDevice"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.modules.gwt.datastructure.usermanager.RequestConsts"%>
<%@page import="java.net.InetAddress"%>
<%@page import="com.erad.pacs.services.usermanager.client.Envelope"%>
<%@page import="java.security.PrivateKey"%>
<%@page import="java.security.KeyStore.PrivateKeyEntry"%>
<%@page import="com.erad.pacs.toolbox.KeystoreToolbox"%>
<%@page import="cases.ActionjspKeystoreParam"%>
<%@page
	import="com.erad.pacs.modules.gwt.descriptors.usermanager.LoginWithKeyModule"%>
<%@page import="java.nio.file.StandardCopyOption"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Enumeration"%>
<%@page import="java.nio.file.Files"%>
<%@page import="java.nio.file.Paths"%>
<%@page import="java.nio.file.Path"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page
	import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.dotcom.DotcomConfig"%><%--
* Component: cases
*
* Description:
*  Interface for uploading a study (to the given HUB), extracting it and importing to the worklist
*
* Parameters (multipart):
*
*   cFile         The content of the new DICOM object
*
* Last Updated     : $Author$
* Update Date Time : $Date$
* RCS File Name    : $RCSfile$
* RCS Revision     : $Revision$
* Locked by        : $Locker$
* Symbolic name    : $Name$
* State            : $State$
*
--%><%@
	page
	import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.types.flag.IMTypeur"%><%@
	page
	errorPage="../main/exceptionHandler.jsp"%><%!// "true" means : return from this jsp, either because of redircet or because of problem 
	boolean checkTargethubAndRedir( Session sess, String targetHUB, HttpServletResponse response, JspWriter out ) {
		try {
			Helper.DEBUG( "Checking targethub:" + targetHUB );
			if ( targetHUB != null && !"".equals( targetHUB ) && !targetHUB.equals( DotcomConfig.selfId() ) ) {
				//redirect, multi params are not needed, they will be included in writeMultipartBodyTo
				String device = DotcomConfig.getConfig().getServerNameTowards( targetHUB );
				if ( device != null ) {
					String idBase = RedirectToolbox.getURL( device, sess.getClientAddress().getHostAddress(), null );
					if ( idBase != null && !"".equals( idBase ) ) {
						StringBuilder sb = new StringBuilder( idBase );
						sb.append( "/cases/uploadImportStudy.jsp" );
						if ( sess.getSessionId() != null ) {
							sb.append( "?sessionid=" + sess.getSessionId() );
						}
						Helper.DEBUG( "uploadImportStudy redirected to:" + sb.toString() );
						response.sendRedirect( sb.toString() );
						return true;
					}
				}
			}
		}
		catch ( Throwable th ) {
			Helper.defaultCatch( th );
			try {
				out.print( "FAILED" );
			}
			catch ( Throwable t2 ) {
				Helper.defaultCatch( t2 );
			}
			return true; // 
		}
		return false;
	}%>
<%
	Helper.DEBUG( "BUU NEW uploadImportStudy jsp called" );

	Helper.DEBUG( "uploadImportStudy.jsp session id param:" + request.getParameter( RequestConsts.QUERYSTRING_SESSION_ID_NAME ) );

	/*	
		Enumeration<String> headerNames = request.getHeaderNames();
		while (headerNames.hasMoreElements()) {
			String headerName = headerNames.nextElement();
			String he = request.getHeader( headerName );
			Helper.DEBUG( "upload Header Name:" + headerName + " value:" + he );
		}
	
		Helper.DEBUG( "upload method:" + request.getMethod(  ) );
		Helper.DEBUG( "upload content type:" + request.getContentType(  ) );
	*/

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );

	Helper.DEBUG( "BUU uploadImportStudy jsp called (2)" );

	Session sess = UserRequestResponseToolbox.getSessitaSession( request, response );

	if ( !sess.getRights().hasRight( PacsRight.ImportCD ) ) {
		response.setStatus( 403 );
		return;
	}

	boolean isRedirOnly = "true".equals( request.getHeader( "RedirectOnly" ) );

	Helper.DEBUG( "BUU uploadImportStudy jsp called (3), RedirectOnly:" + request.getHeader( "RedirectOnly" ) );

	boolean isV8 = "true".equals( request.getHeader( "V8Upload" ) );
	String targetHUB = request.getHeader( "TargetHUB" );
	if ( checkTargethubAndRedir( sess, targetHUB, response, out ) ) {
		return;
	}
	// this 1st check is when in v8 we got target hub from header

	if ( isRedirOnly ) {
		// if it's a 'dummy' call which is for redirection only, we DON'T parse Multipart here, we arrived to destination, so just give back empty 200
		return;
	}

	MultipartRequest mp = new MultipartRequest( request, IMEnvBase.getEnv( "TMP" ) );

	targetHUB = mp.getParameter( "cTargetHUB" );
	// this 2nd check is when from 72 we got target hub from parameter
	if ( checkTargethubAndRedir( sess, targetHUB, response, out ) ) {
		return;
	}

	String[] parStudyUIDs = mp.getParameterValues( "cGr" );
	String parFile = mp.getParameter( "cFile" );
	//tmp file name will be in it - for 72

	boolean createDicomdir = !"true".equals( mp.getParameter( "cDicomdir" ) );
	boolean isCompressedv8 = "true".equals( request.getHeader( "Compression" ) );

	Helper.DEBUG( "BUU uploadImportStudy after Multipart request, targetHUB:" + targetHUB + "; session ID: " + sess.getSessionId() + "; userid: " + sess.getUser().getUserId() + "; studies: " + Helper.toString( parStudyUIDs ) + "; createDicomdir: " + Helper.toString( createDicomdir ) + "; Compression: "
			+ Helper.toString( isCompressedv8 ) );


	if ( !mp.isMultiPart() ) {
		Helper.DEBUG( "Not Multipart request" );
		out.print( "FAILED, not a Multipart request" );
		response.setStatus( 500 );
		return;
	}
	else {
		DotcomDevice selfDevice = DotcomConfig.selfDevice();	
		if ( selfDevice.isDbOnly() ) {
			Helper.ERRORLOG( "I'm CWL and there was no redirect! TargetHUB header is:'" + request.getHeader( "TargetHUB" ) + "' and TargetHUB parameter is:'" + targetHUB );
			out.print( "FAILED, trying to upload directly to CWL, invalid Target HUB: " + request.getHeader( "TargetHUB" ) );
			response.setStatus( 500 );
			return;
		}

		String tempShortName = "importstudies." + System.currentTimeMillis();
		Path tempDir = Paths.get( IMEnvBase.getEnv( "SHARED_TMP" ) ).resolve( tempShortName );

		try {
			if ( !isV8 ) {
				Helper.INFOLOG( "Upload study request arrived from a 72 server, studies:" + Helper.toString( parStudyUIDs ) );
				Helper.extractFilesFromZip( parFile, tempDir.toString(), false );
				String problem = DicomDirToolbox.startImporting( sess, parStudyUIDs, tempShortName, true );
				if ( problem != null ) {
					Helper.ERRORLOG( "Upload study request FAILED, problem with importing:" + problem );
				}
				else {
					Helper.INFOLOG( "Upload study request started importing" );
				}
				Helper.DEBUG( "return value:'FILE:" + parFile + "'" );
				out.print( "FILE:" + parFile );
			}
			else {
				Path rootPath = Paths.get( "/" );

				Files.createDirectories( tempDir );
				// move files into its original subdir on its original name for the DICOMDIR (also changing \ to /)
				// DICOMDIR is also included in the files
				Enumeration<String> parNames = mp.getParameterNames();
				int renameNum = 0;
				String renamePrefix = "E_";
				while ( parNames.hasMoreElements() ) {
					String par = parNames.nextElement();
					Helper.DEBUG( "parametername: " + par + " value:" + mp.getParameter( par ) );
					if ( par.startsWith( "cFile" ) ) {
						String fileName = mp.getParameter( par ); // saved file name
						String origName = mp.getFileNameFor( par );
						Helper.DEBUG( "filename: " + fileName + " origname: " + origName );
						if ( fileName != null && origName != null ) {
							Path origPath = Paths.get( origName.replace( '\\', '/' ) );
							if ( origPath.isAbsolute() ) {
								origPath = rootPath.relativize( origPath );
							}
							Path destFile = tempDir.resolve( origPath );
							Helper.DEBUG( "destFile: " + destFile );

							String shortName = destFile.getFileName().toString();
							Path parentDir = destFile.getParent();
							Files.createDirectories( parentDir );

							Helper.DEBUG( "parentDir: " + parentDir );
							Helper.DEBUG( "shortFileName: " + shortName );

							if ( createDicomdir && ( shortName.length() > 8 || !shortName.matches( "[A-Z0-9_]+" ) ) ) {
								String rename = renamePrefix + renameNum;
								while ( Files.exists( parentDir.resolve( rename ) ) ) {
									Helper.DEBUG( "already exists: " + parentDir + "/" + rename );
									renameNum++;
									rename = renamePrefix + renameNum;
								}
								destFile = parentDir.resolve( rename );
								Helper.DEBUG( "shortFileName is not correct, will be uncompressed/renamed to: " + destFile );
								renameNum++;  // for the next problematic file
							}
							
							if ( isCompressedv8 ) { // will be true allways
								Helper.extractFileFromDeflate( fileName, destFile.toString() );
							}
							else {
								Path src = Paths.get( fileName ); // fileName is the absolute path.
								Files.move( src, destFile, StandardCopyOption.ATOMIC_MOVE );
								Helper.DEBUG( "file moved from " + fileName + " to " + destFile );
							}
						}
					}
				}

				Helper.INFOLOG( "Upload study request arrived, createdicomdir:" + createDicomdir + ", studies:" + Helper.toString( parStudyUIDs ) );

				if ( createDicomdir ) {
					List<String> cmd = new ArrayList<String>();
					cmd.add( IMEnvBase.getEnv( "CD_HOME" ) + "/createdicomdir.sh" );
					cmd.add( tempDir.toString() );
					Helper.DEBUG( "dicomdir creation command is " + Helper.toString( cmd ) );
					RunCommandResult result = Helper.runCommandEx( cmd.toArray( new String[ cmd.size() ] ) );
					if ( result.getExitCode() == 0 ) {
						Path dicomdirFile = tempDir.resolve( "DICOMDIR" );
						Helper.DEBUG( "dicomdir created:" + dicomdirFile );
					}
					else {
						Helper.ERRORLOG( "dicomdir creation problem:" + result.getError() );
						String output = Helper.readTextFile( tempDir.resolve( "createdicomdiroutput" ).toString() );
						out.println( "FAILED, couldn't create DICOMDIR" );
						if ( output != null ) {
							Helper.ERRORLOG( "dicomdir creation output: " + output );
							out.println( "Problem is: " + output );
						}
						response.setStatus( 500 );

						// ez igy nem torli a tempdirt, de ez nem baj, mert legalabb meg tudjuk invesztigalni utolag, mi a gond - es 3 nap utan ugyis torlodik
						return;
					}
				}

				String problem = DicomDirToolbox.startImporting( sess, parStudyUIDs, tempShortName, true );
				if ( problem != null ) {
					Helper.ERRORLOG( "Upload study request FAILED, problem with importing:" + problem );
					out.print( "FAILED, couldn't start importing, see error.log for details" );
					response.setStatus( 500 );
				}
				else {
					Helper.INFOLOG( "Upload study request started importing" );
					out.print( "OK" );
					Helper.DEBUG( "return value:'OK'" );
				}

				//			Helper.removeDirectoryRecursively( tmpDirName );
			} // if ( isV8 )
		}
		catch ( Throwable th ) {
			Helper.ERRORLOG( "Exception in media import extracting (to " + tempDir + ") :" + Helper.throwable2String( th ) );
			out.print( "FAILED, couldn't extract uploaded files" );
			response.setStatus( 500 );
		}


		return;
	}
%>