<%--
 * Component: cases
 *
 * Description:
 *    Download user profile for the viewer.
 *
--%><%@page import="imagemed.util.Helper,
		com.erad.pacs.connector.Connector,
		com.erad.pacs.services.usermanager.client.Session,
		com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
		com.erad.pacs.toolbox.UserRequestResponseToolbox,
		com.erad.pacs.viewer.XmlRoutines,
		com.erad.pacs.toolbox.ChecksumToolbox,
		com.erad.pacs.viewer.generate.generatedFiles.RootConfig"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = UserRequestResponseToolbox.getSessitaSessionNoSessParCheck( request, response );
		 
	Helper.DEBUG( "viewerVersion:" + request.getHeader( "ViewerVersion" ) );
	
	String strProfileData = "";
	String strUserPart = "";
	try {
		RootConfig rootConfig = XmlRoutines.getXml( sess, request.getHeader( "ViewerVersion" ) );
		if (rootConfig != null) {
			strUserPart += rootConfig.getConfig() == null ? null : rootConfig.getConfig().getUser();
			strProfileData += rootConfig.getXMLValue( false, true );		
		}
	} catch (Throwable t) {
		// when unexpected error happens, return the error message instead of the profile xml text
		strProfileData += t.getMessage() != null ? t.getMessage() : t.getCause().getMessage();
		Helper.defaultCatch( t );
	}

	response.addHeader( "Content-Type", "text/xml;charset=utf-8" );
// we don't set, because:
// this way it's not correct
// the getBytes() way is inefficient
//	response.setHeader( "Content-length", Long.toString( strProfileData.length() ) );
	response.setHeader( "Pragma", "no-cache" );

	// add viewer profile checksum information SRV-1237; use only the user part to create the checksum SRV-1997
	String checksumHexString = ChecksumToolbox.createChecksumHexString( strUserPart );
	response.setHeader( "ViewerProfileChecksum", checksumHexString );

	out.print( strProfileData );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
