#!/bin/bash
##########################################
# DEPRECATED ONLY EXIST FOR COMPATIBILITY
##########################################
# Component: dotcom
#
# Description:
#   Proliferates a file in the dotcom.
#
#
# Last Updated     : $Author: pzahorcsek $
# Update Date Time : $Date: 2014/03/13 15:28:57 $
# RCS File Name    : $RCSfile: proliferate.sh,v $
# RCS Revision     : $Revision: 1.19 $
# Locked by        : $Locker:  $
# Symbolic name    : $Name:  $
# State            : $State: Exp $
#

. $HOME/etc/setenv.sh

LOGGER="/usr/bin/logger"
TAG="proliferate[$$]"

while getopts 'f:x:d:r:a:R:I:n' OPT; do
	case $OPT in
		f) FILENAME="$OPTARG" ;;
		x) EXCEPT="$OPTARG" ;;
		d) DIRECTION="$OPTARG" ;;
		r) PSCRIPTNAME="-r \"$OPTARG\"" ;;
		a) PSCRIPTARGS="$PSCRIPTARGS -a \"$OPTARG\"" ;;
		R) REFCOUNTTYPE="$OPTARG";;
		I) REFCOUNTID="$OPTARG" ;;
		n) EXCLUDE_DBONLY="-n" ;;
		*) ERRMSG="Invalid_Parameter:$OPT" ;;
	esac
done

case $FILENAME in
    *"$SHARED_CONF"*)
         
         ;;
	*)
		echo "Use the \$SHARED_CONF folder to do this rather than this folder."
		;;
esac 

return 0