#!/bin/bash
# Component: dotcom
#
# Description:
#   Sync all study.
#
# Usage:
#    syncAll.sh 
#

. $HOME/etc/setenv.sh
. $HOME/component/tools/scripttools.shi

[ -f "$CONF/serverid.cfg" ] && . "$CONF/serverid.cfg"
JOB_ID="$SELF_SERVER_ID-SYNC$(date +%s)"

${TOOLS_HOME}/sql.sh "select STYIUID from Dcstudy" -N | \
while read study; do
	niceme && break

	$TASKD_HOME/createtaskfileapp -p "STUDY_SYNCHRONIZER" -j "$JOB_ID" -t "class" -c "dotcom.StudySynchronizerTask -f -s \"$study\""
done
