<%--
 * Component: cases
 *
 * Description:
 *    Get License Request
 *
 * Parameters:
 *		cFile					: csr file name, no folder
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@ page trimDirectiveWhitespaces="true" %>
<%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.http.Range, imagemed.license.*, org.w3c.dom.Document, javax.xml.parsers.*, 
	imagemed.imsession.*,imagemed.util.*, imagemed.jsputil.*,java.io.File,imagemed.exception.*"
%><%
	String fname = request.getParameter( "cFile" );
	if( fname == null || fname.contains( "/" ) ) {
		Helper.ERRORLOG( "/ in filename: " + fname );
		response.setHeader("Content-type","text/html");
		out.print( "FAILED, invalid cFile:" + fname );
		return;
	}
	

	String newCertFilename = IMEnvBase.getEnv( "OPENSSL_CERT_DIR" ) + "/" + fname;
	try {
		response.setContentType( "application/octet-stream" );
		response.setHeader("Content-Disposition", "attachment; filename=" + fname );
		
		Range range = new Range( request, response );
	
		range.sendRequestedRange( newCertFilename );
	}
	catch( Throwable t1 ) {
		// not found or other I/O error
		
		//response.setStatus(404);
		response.setHeader("Content-type","text/html");
		String msg = "FAILED, not existing csr file:" + newCertFilename;
		response.setHeader("Content-length", Integer.toString(msg.length()));
		out.print(msg);
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}%>