<%--
 * Component: cases
 *
 * Description:
 *   Simple callback hook test.
 *
 * Parameters:
 *
 *  @param cCallbackList         Multipart file containing the callback information.
 *
--%><%@
	page import = "imagemed.jsputil.AttachmentManager, imagemed.util.*, java.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%>
<html>
<body>
<%
 	out.println( "testCallback.jsp... " );
	
	MultipartRequest mp = new MultipartRequest( request, AttachmentManager.getTempDir() );
	String tmpFileName = mp.getParameter("cCallbackList");
	if (tmpFileName==null) {
		Helper.INFOLOG( "testCallback.jsp: cCallbackList parameter is NULL!" );
		out.println( "Missing 'cCallbackList' parameter!" );
	} else {
		Helper.INFOLOG( "testCallback.jsp: Read callback list from " + tmpFileName );
		String content = Helper.readTextFile( tmpFileName );
		Helper.INFOLOG( "testCallback.jsp: Callback file content: " + content );
		out.println( "OK" );
	}
	mp.close( );

%>	
	
</body>
</html>
