<%--
 * Component: cases
 *
 * Description:
 *    Download user profile for the viewer.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="imagemed.util.UserPreferences.Option"%>
<%@
	page import="com.erad.pacs.services.usermanager.client.Session"
	
%><%@
	page import="imagemed.util.*,java.io.*,java.sql.*, imagemed.imsession.*,java.util.*, imagemed.jsputil.*"
	
%><%@
	page errorPage ="../../main/exceptionHandler.jsp"
	
%><%
		
	String language = request.getParameter( "language" );
	String strResponse;
	
	if( language != null ) {
		Helper.DEBUG( "language got:" + language );
		
		// check if it's legal
		// we get: _en_US
		// we have: enUS
		boolean legal = false;
		List<Option> optList = LocalizedMessage.parseAvailableLanguages();
		for ( int i = 0; i < optList.size(); i++ ) {
			Option opt = optList.get( i );
			if ( opt != null ) {
				String lan = opt.getValue();
				if( lan != null && lan.length() >= 4 ) {
					if( language.equals( "_" + lan.substring( 0, 2 ) + "_" + lan.substring( 2, 4 ) ) ) {
						legal = true;
						Helper.DEBUG( "language legal with:" + lan );
					}
				}
			}
		}
		if( !legal ) {
			response.sendError( 403, "ERROR: language parameter not supported" );
			return;
		}
		
		String fileName = IMEnvBase.getEnv( "VIEWERDEFAULTS_HOME" ) + "/Viewer" + language + ".properties";
		Helper.DEBUG( "language file name:" + fileName );
		if( new File( fileName ).exists() ) {
			try { 
				InputStream inputStream = new FileInputStream( fileName );
				response.setContentType( "text/plain" );
				response.setHeader( "Pragma","no-cache" );
			    inputStream.transferTo( response.getOutputStream() );
			    inputStream.close();
			    return;
			}
			catch( Exception e ) {
				response.sendError( 403, "ERROR: File reading error:" + Helper.throwable2String( e ) );
				return;
			}

			
//			strResponse = Helper.readTextFile( fileName );				
		}
		else {
			// empty result
			response.setContentType( "text/plain" );
			response.setHeader( "Pragma","no-cache" );
			return;
		}
	}
	else {
		strResponse = "ERROR: no language parameter"; 
		response.sendError( 403, strResponse );
		return;
	}
%>